
#include <stdio.h>
#include <math.h>


/*
  calcola le soluzioni x1 e x2 di un'equazione di secondo grado di coefficienti a, b e c
  restituisce -1 in caso di errore, 0 altrimenti
*/
int equazione(float a, float b, float c, float* x1, float* x2)
{
 float delta = b*b - 4*a*c; // discriminante

 if (delta<0 || a==0)
   return -1;
 *x1 = (-b + sqrt(delta)) / (2*a);
 *x2 = (-b - sqrt(delta)) / (2*a);
 return 0;
}


void main(void)
{
 float a, b, c, x1, x2;

 printf("Coefficiente del termine di secondo grado? ");
 scanf("%f", &a);
 printf("Coefficiente del termine di primo grado? ");
 scanf("%f", &b);
 printf("Coefficiente del termine noto? ");
 scanf("%f", &c);

 if (equazione(a, b, c, &x1, &x2) < 0)
   printf("Errore, non esistono soluzioni\r\n");
 else
	 printf("Le soluzioni dell'equazione sono %f e %f\r\n", x1, x2);
}
