
#include <stdio.h>
#include <math.h>


/*
  calcola la media M e la varianza V di un vettore v di n elementi
*/
void statistica(float v[], int n, float* M, float* V)
{
 float somma=0, somma_quadrati=0;
 int i;

 // ciclo di calcolo della somma degli elementi e della somma dei quadrati degli elementi
 for (i=0; i<n; i++)
    {
	 somma += v[i];
	 somma_quadrati += v[i]*v[i];
    }
 // calcolo della media e della varianza
 *M = somma/n;
 *V = somma_quadrati/n -(*M)*(*M);
}


void main(void)
{
 float vettore[10] = {-2.5, -2, -1.5, -1, -0.5, 0, 0.5, 1, 1.5, 2};
 float media, varianza;

 statistica(vettore, 10, &media, &varianza);

 printf("La media degli elementi e' %f\r\n", media);
 printf("La varianza degli elementi e' %f\r\n", varianza);
}
