
#include "pasqua.h"


int numeroPasquale(int a)
{
 int g, c, x, z, d, e, n;

 g = a%19+1;
 c = a/100+1;
 x = 3*c/4-12;
 z = (8*c+5)/25-5;
 d = 5*a/4-x-10;
 e = (11*g+20+z-x)%30;
 if (((e == 25) && (g > 11)) || (e == 24))
   e++;
 n = 44-e;
 if (n < 21)
   n += 30;
 n = n+7-(d+n)%7;
 
 return n;
}


void Pasqua(int anno, int *giorno, int *mese)
{
 int N = numeroPasquale(anno);
 if (N > 31)
   {
    *mese = 4;
    *giorno = N-31;
   }
 else
     {
      *mese = 3;
      *giorno = N;
     }
}
